import java.util.Vector;

public class Cadre extends Employe {
   
    private  Vector<Employe> subordonnes = new Vector<Employe>();
    /**
     * Constructeur
     */

    public Cadre(String nom, int genre) {
	super(nom, genre);
    }

    public Cadre(String nom, int genre, Cadre superieur)  throws Exception{
	super(nom, genre, superieur);
    }
    /**
     * accesseur pour le nom. Dans le cas d'un cadre le nom est précédé Mr ou Mme
     */
    public String getNom() {
    	if (this.getGenre() == _HOMME) {
	    return("Mr "+ super.getNom());
	}
	return ("Mme "+  super.getNom());
    }

    /**
     * Ajoute un subordonné
     */
    void ajouteSubordonne(Employe e) throws Exception  {
	if (this.subordonnes.contains(e))  throw new Exception(e.getNom()+" est déjà au service de "+this.getNom());
	this.subordonnes.add(e);
    }
    
    /**
     * Calcul le salaire
     */
    public double getSalaire() {
	double result =  Employe.salaire_base;
    	for (Employe e : this.subordonnes) {
	    result = result + 0.4*(e.getSalaire());
	}
	return result;
    }


    // Questions facultatives:

   /**
     * Enleve un subordonné
     */
    void enleveSubordonne(Employe e)  throws Exception {
	if (!this.subordonnes.contains(e))  throw new Exception(e.getNom()+" n'a pas pour supérieur direct "+ this.getNom());
	this.subordonnes.remove(e);
    }

    /**
     * Affiche sur la sortie standard la liste des subordonnés directs
     */
    public void afficheSubordonnes() {
	System.out.println(this.getNom()+ " a "+ subordonnes.size()+ " subordonnés directs :");
	for (Employe e : this.subordonnes) {
	    System.out.println(e.getNom());
	}
    }

    /**
     * Description du service sur la sortie standard
     */
    public void descriptionService() {
	System.out.print("Service de ");
	System.out.println("Ce service est composé de " + afficheService("")+ " personnes.");  
    }

    /**
     * méthode appelée par descriptionService. Elle affiche le service  avec l'indentation mis en argument et retourne le nombre de personnes du service
     */
    int afficheService(String ind) {
	int res = super.afficheService(ind);
	if (subordonnes.size()==0) return res;
	if (this.getGenre()==  _HOMME) {
	    System.out.println(ind+" supérieur de :");
	}
	else {
	    System.out.println(ind+" supérieure de :");
	}
	ind = ind+"  ";
	for (Employe e : this.subordonnes) {
	    res = res+e.afficheService(ind);
	}
	return res;
    }

    // Méthode utilisée par retireEmploye dans la classe Entreprise
    void retireDeEntreprise(Entreprise ent){
	super.retireDeEntreprise(ent);
	for  (Employe e : this.subordonnes) {
	    e.retireDeEntreprise(ent);
	}
    }
   
}